/**************************************************************************************************
 mɂxCY̒PQIIfUCSAS}N

 QlFThall PF and Simon R. Biometrics 50(2), 337-349, 1994

 ӁFRCXg[ς݂ŁARLANGLł邱
       PROC IMLp[g̎svÓA{vOƓtH_ɕۑ邱

 }Nϐ
 aS, bS: WÂ̔̎Ozp[^ 
 aE, bE: Â̔̎Ozp[^
 d0: ÂɊւ锽̍Œe\ȑ
 pE: Â̊Ҕ
 min, max: j^Oᐔ
 bdL, bdU: JbgItm

**************************************************************************************************/


%let execpath = " ";
%let Path = " ";

%macro setexecpath;
%let execpath = %sysfunc(getoption(sysin));
%if %length(&execpath) = 0 %then %let execpath = %sysget(sas_execfilepath);
data _null_;
  do i = length("&execpath") to 1 by -1;
    if substr("&execpath", i, 1) = "\" then do;
      call symput("Path", substr("&execpath", 1, i));
      stop;
    end;
  end;
run;
%mend setexecpath;

%setexecpath;


FILENAME saspgm "&path";


%macro ThallSimon(aS, bS, aE, bE, d0, pE, min, max, bdL, bdU);

footnote1 "OzFÂ̔`Beta(&aE., &bE.), WÂ̔`Beta(&aS., &bS.)";
footnote2 "WÂƔrƂ̎ÂɊւ锽̍Œe\ȑF&d0";
footnote3 "ɂ鎎Â̔F&pE.";
footnote4 "j^OTvTCY͈̔́F&min.`&max.";
footnote5 "mJbgItlF &bdL., 㑤 &bdU." ;


/*PROC IMLp[gs*/
%INCLUDE saspgm(yD-10z{_SubmitR.sas) / SOURCE2;  

%if &bdU= %then %do;
data bound;
  set bound;
  U=.;
run;
%end;

title "~E";
proc sgplot data=bound noautolegend;
  xaxis label="]ᐔ" values=(0 to &max);
  yaxis label="ᐔ";
  series x=n y=U 
        / lineattrs=(color=red pattern=1 thickness=2) name="upper" legendlabel="L~E";
  series x=n y=L 
        / lineattrs=(color=blue  pattern=1 thickness=2) name="lower" legendlabel="~E";
  keylegend "upper" "lower" 
        / across=1 location=inside position=bottomright ;
run;
title;

/*ZoȂEᐔ͎肦Ȃlɐݒ*/
data bound2;
  set bound;
  if U=. then U=&max+1;
  if L=. then L=-1;
run;

proc iml;
  use bound2;
  read all var {U} into upper;
  read all var {L} into lower;

  /*N~(N+1)s쐬B]ᐔ~(ᐔ+1)Ƃčl*/
  pmx=j(&max, &max+1, 0);
  p=&pE;
  q=1-p;

  pplus  =j(&max,1, 0);
  pminus =j(&max,1, 0);
  cpplus =j(&max,1, 0);
  cpminus=j(&max,1, 0);
  cpstop =j(&max,1, 0);
  cpconti=j(&max,1, 0);
  size =t(1:&max);

  do y=0 to &min;
    /*]ᐔmin̏ꍇɂ͓񍀊mvZ*/
    pmx[&min,y+1] = comb(&min,y) * p**y * q**(&min-y) * ((lower[&min] < y) & (y < upper[&min]));
    pplus[&min]   = pplus[&min]  + comb(&min,y) * p**y * q**(&min-y) * (y >= upper[&min]);
    pminus[&min]  = pminus[&min] + comb(&min,y) * p**y * q**(&min-y) * (y <= lower[&min]);
  end;
  cpplus[&min]  = pplus[&min];
  cpminus[&min] = pminus[&min];
  cpstop[&min]  = cpplus[&min] + cpminus[&min];
  cpconti[&min] = 1 - cpstop[&min];

  do n=&min+1 to &max;
    pmx[n,1] = (q*pmx[n-1,1]) * ((lower[n] < 0) & (0 < upper[n]));
    do y=1 to n;
    /*]ᐔmin+1̏ꍇɂ́Axk[Cߒ̃}RtpāA1sO̊mgċA[IɌvZ*/
      pmx[n,y+1] = (q*pmx[n-1,y+1] + p*pmx[n-1,y]) * ((lower[n] < y) & (y < upper[n]));
      pplus[n]   = pplus[n] + (q*pmx[n-1,y+1] + p*pmx[n-1,y]) * (y >= upper[n]);
      pminus[n]  = pminus[n] + (q*pmx[n-1,y+1] + p*pmx[n-1,y]) * (y <= lower[n]);
    end;
    cpplus[n]  = cpplus[n-1] + pplus[n];
    cpminus[n] = cpminus[n-1] + pminus[n];
    cpstop[n]  = cpplus[n] + cpminus[n];
    cpconti[n] = 1 - cpstop[n];
  end;
  result=size||pplus||cpplus||pminus||cpminus||cpstop||cpconti;
  create result from result [colname={n p_plus cp_plus p_minus cp_minus cp_stop cp_conti}];
  append from result;

quit;

data result;
  merge bound result;
  by n;
  label n="]*ᐔ" U="L~*Eᐔ" L="~*Eᐔ" p_plus="L~*m" p_minus="~*m"
        cp_plus="L~m (ݐ)" cp_minus="~m (ݐ)" cp_stop="~m (ݐ)" cp_conti="~Ȃ*m";
run;

title "őᐔ܂Ńj^OƂ̒~m";
proc print data=result noobs label split="*";
  where n=&max;
  format cp_plus cp_minus cp_stop cp_conti 8.3; 
  var    cp_plus cp_minus cp_stop cp_conti;
run ;

proc transpose data=result out=result2;
  by n;
  var cp_plus cp_minus;
run;

title "]ᐔƂ̒~m";
proc sgplot data=result2;
  vbar n 
    / response=col1 group=_label_ groupdisplay=stack grouporder=descending transparency=0.3;
  xaxis label="]ᐔ" values=(&min to &max);
  yaxis label="ݐϒ~m" values=(0 to 1 by 0.25);
  refline 0.25 0.5 0.75 / axis=y lineattrs=(pattern=2);
  keylegend 
        / title="" across=1 location=inside position=topleft sortorder=ascending;

run;

title "]ᐔɑ΂钆~Eᐔƒ~m";
proc print data=result noobs label split="*";
  where &min <= n <= &max;
  format       p_plus cp_plus p_minus cp_minus cp_stop 8.3;
  var    n U L p_plus cp_plus p_minus cp_minus cp_stop;
run ;

%mend ;


/*FThall & Simoñe[u1*/
%ThallSimon(aS=8.15, bS=32.6, aE=0.55, bE=1.45, d0=0.15, pE=0.20, min=10, max=65, bdL=0.05, bdU=0.95);
%ThallSimon(aS=8.15, bS=32.6, aE=0.55, bE=1.45, d0=0.15, pE=0.40, min=10, max=65, bdL=0.05, bdU=0.95);
